@Echo off

Echo.
Echo  Simple CA utility
Echo  Written by Artur Maj (artur.maj@seccure.net)
Echo.

if %1.==genca. goto genca
if %1.==client. goto client
if %1.==server. goto server

:help
Echo  Usage:
Echo    ca genca    - generate CA certificate
Echo    ca server   - generate and sign server certificate
Echo    ca client   - generate and sign client certificate
Echo.
goto exit

:genca
if not exist %OPENSSLBINDIR%\openssl.exe goto ssldoesntexist
if not exist %OPENSSLCADIR% goto genca2
Echo Warning!
Echo The content of the CA directory will be removed.
Echo Press CTRL-C to break, or ENTER to continue...
Echo.
pause > nul
Echo Removing CA...
rmdir /S /Q %OPENSSLCADIR% > nul
goto genca3

:genca2
Echo The script will create the CA directory structure needed by
Echo OpenSSL, and generate CA Certificate.
Echo.
Echo Press CTRL-C to break, or ENTER to continue...
Echo.
pause > nul

:genca3
Echo Creating CA...
mkdir %OPENSSLCADIR%
Echo Creating %OPENSSLCADIR%\certs...
mkdir %OPENSSLCADIR%\certs
Echo Creating %OPENSSLCADIR%\crl...
mkdir %OPENSSLCADIR%\crl
Echo Creating %OPENSSLCADIR%\newcerts...
mkdir %OPENSSLCADIR%\newcerts
Echo Creating %OPENSSLCADIR%\private...
mkdir %OPENSSLCADIR%\private
Echo Creating %OPENSSLCADIR%\temp...
mkdir %OPENSSLCADIR%\temp
Echo Creating CA index file...
copy nul %OPENSSLCADIR%\index.txt > nul
Echo Creating CA serial file...
echo 54064034038470340357406837034035406870340354360840351003540684031403654706703403540687035403132407805310321408907694064035> %OPENSSLCADIR%\serial
Echo.
Echo --------------------------------------------------------------------
Echo  Generating the CA's certificate...
Echo --------------------------------------------------------------------
Echo.
%OPENSSLBINDIR%\openssl.exe req -new -x509 -keyout %OPENSSLCADIR%\private\CAkey.pem -out %OPENSSLCADIR%\CAcert.pem -config %OPENSSLBINDIR%\openssl.conf
goto exit

:client
if not exist %OPENSSLBINDIR%\openssl.exe goto ssldoesntexist
if not exist %OPENSSLCADIR%\CAcert.pem goto cadoesntexist
if not exist %OPENSSLCADIR%\temp\vnc_client goto client2
Echo  Warning!
Echo  The content of the %OPENSSLCADIR%\temp\vnc_client directory will be removed.
Echo  Press CTRL-C to break, or ENTER to continue...
pause > nul
rmdir /s /q %OPENSSLCADIR%\temp\vnc_client > nul

:client2
mkdir %OPENSSLCADIR%\temp\vnc_client
Echo --------------------------------------------------------------------
Echo  Step 1: Generate the keys and the certificate request
Echo --------------------------------------------------------------------
Echo.
%OPENSSLBINDIR%\openssl.exe req -nodes -config %OPENSSLBINDIR%\openssl.conf -new -newkey rsa:1024 -keyout %OPENSSLCADIR%\temp\vnc_client\client.key -out %OPENSSLCADIR%\temp\vnc_client\client.req
Echo.
Echo --------------------------------------------------------------------
Echo  Step 2: Sign the certificate
Echo --------------------------------------------------------------------
Echo.
%OPENSSLBINDIR%\openssl.exe ca -config %OPENSSLBINDIR%\openssl.conf -policy policy_anything -notext -in %OPENSSLCADIR%\temp\vnc_client\client.req -out %OPENSSLCADIR%\temp\vnc_client\client.crt
copy %OPENSSLCADIR%\temp\vnc_client\client.key + %OPENSSLCADIR%\temp\vnc_client\client.crt %OPENSSLCADIR%\temp\vnc_client\client.pem > nul
del /Q %OPENSSLCADIR%\temp\vnc_client\client.req
goto exit

:server
if not exist %OPENSSLBINDIR%\openssl.exe goto ssldoesntexist
if not exist %OPENSSLCADIR%\CAcert.pem goto cadoesntexist
if not exist %OPENSSLCADIR%\temp\vnc_server goto server2
Echo  Warning!
Echo  The content of the %OPENSSLCADIR%\temp\vnc_server directory will be removed.
Echo  Press CTRL-C to break, or ENTER to continue...
pause > nul
rmdir /s /q %OPENSSLCADIR%\temp\vnc_server > nul

:server2
mkdir %OPENSSLCADIR%\temp\vnc_server
Echo --------------------------------------------------------------------
Echo  Step 1: Generate the keys and the certificate request
Echo --------------------------------------------------------------------
Echo.
%OPENSSLBINDIR%\openssl.exe req -nodes -config %OPENSSLBINDIR%\openssl.conf -new -newkey rsa:1024 -keyout %OPENSSLCADIR%\temp\vnc_server\server.key -out %OPENSSLCADIR%\temp\vnc_server\server.req
Echo.
Echo --------------------------------------------------------------------
Echo  Step 2: Sign the certificate
Echo --------------------------------------------------------------------
Echo.
%OPENSSLBINDIR%\openssl.exe ca -config %OPENSSLBINDIR%\openssl.conf -policy policy_anything -notext -in %OPENSSLCADIR%\temp\vnc_server\server.req -out %OPENSSLCADIR%\temp\vnc_server\server.crt
copy %OPENSSLCADIR%\temp\vnc_server\server.key + %OPENSSLCADIR%\temp\vnc_server\server.crt %OPENSSLCADIR%\temp\vnc_server\server.pem > nul
del /Q %OPENSSLCADIR%\temp\vnc_server\server.req
goto exit

:ssldoesntexist
Echo Error while accessing %OPENSSLBINDIR%\openssl.exe!
goto exit

:cadoesntexist
Echo  CA certificate doesn't exist! Run "ca genca" first.
Echo.
goto exit

:exit
